﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.TreeGrid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Interactivity;

namespace OnDemandLoading
{
    class RequestTreeItemsBehavior : Behavior<SfTreeGrid>
    {
        ViewModel viewModel;
        protected override void OnAttached()
        {
            base.OnAttached();
            viewModel = this.AssociatedObject.DataContext as ViewModel;
            this.AssociatedObject.RequestTreeItems += AssociatedObject_RequestTreeItems;

        }

        System.Threading.AutoResetEvent autoreset = new System.Threading.AutoResetEvent(false);
        async void AssociatedObject_RequestTreeItems(object sender, TreeGridRequestTreeItemsEventArgs args)
        {
            if (args.ParentItem == null)
            {
                //get the root list - get all employees who have no boss 
                args.ChildItems = viewModel.EmployeeDetails.Where(x => x.ReportsTo == -1); //get all employees whose boss's id is -1 (no boss)
            }
            else //if ParentItem not null, then set args.ChildList to the child items for the given ParentItem.
            {   //get the children of the parent object
                EmployeeInfo emp = args.ParentItem as EmployeeInfo;
                if (emp != null)
                {
                    Task t = Task.Run(() =>
                    {
                        GetChildItem(args);
                    });
                    autoreset.WaitOne();
                }
            }
        }
        private async void GetChildItem(TreeGridRequestTreeItemsEventArgs args)
        {
            EmployeeInfo emp = args.ParentItem as EmployeeInfo;
            args.ChildItems = await viewModel.GetReportees(emp.ID);
            autoreset.Set();
        }

        protected override void OnDetaching()
        {
            base.OnDetaching();
            this.AssociatedObject.RequestTreeItems -= AssociatedObject_RequestTreeItems;
        }
    }
}
